/**
 * @file list.c
 * @brief TODO
 * @author Lukas Hostettler
 * @version 1.0
 * @date TODO
 */

#include "list.h"
#include <stdlib.h>
#include "assert.h"
#define NDEBUG

//TODO: WE MUST TRY TO GET RID OF THESE DYNAMIC ALLOCS, WRITE SPECIALIZED LISTS FOR NEIGHBOURS AND GRID

IntList intListCreate(){
    IntList ans;
    ans.list = 0;
    ans.numAlloc = 0;
    ans.numElements = 0;
    return ans;
}

IntList intListCopy(IntList* dyn){
    IntList ans = intListCreate();
    ans.list = (int*)malloc(dyn->numElements*sizeof(int)); //TODO: GET RID OF THIS MALLOC
    if(ans.list){
        ans.numAlloc = dyn->numElements;
        for(;ans.numElements<dyn->numElements; ++ans.numElements){
            ans.list[ans.numElements] = dyn->list[ans.numElements];
        }
    }
    return ans;
}

void intListPush(IntList* dyn, int element){
    assert(dyn);
    if (dyn->numElements >= dyn->numAlloc){
        assert(dyn->numElements == dyn->numAlloc);
        int newSize = (dyn->numAlloc + 2)*2;
        int* newList = 0;
        if(dyn->list) //TODO: GET RID OF THESE ALLOCS
            newList = (int*)realloc(dyn->list, newSize*sizeof(int));
        else
            newList = (int*)malloc(newSize * sizeof(int));
        if(!newList)
            assert(newList);
        dyn->numAlloc = newSize;
        dyn->list = newList;
    }
    dyn->list[dyn->numElements++] = element; //TODO: EXPAND THIS ONE-LINER
}

int* intListGetPointer(IntList* dyn, int n){
    if(n < dyn->numElements)
        return dyn->list + sizeof(int)*n;
    return 0;
}

void intListShrink(IntList* dyn){
    int* newList = 0;
    newList = (int*)realloc(dyn->list, dyn->numElements*sizeof(int)); //TODO: GET RID OF THIS ALLOC
    if (newList != NULL){
        dyn->list = newList;
        if(newList != dyn->list)
            free(dyn->list);
    }
    else{
        newList = 0;
    }

}

int* intListGetStart(IntList* dyn){
    return dyn->list;
}

int* intListGetEnd(IntList* dyn){
    return dyn->list + dyn->numElements*sizeof(int);
}

void intListFree(IntList* dyn){
    free(dyn->list);
    dyn->list = NULL;
    dyn->numAlloc = 0;
    dyn->numElements = 0;
}

