/**
 * @file point.h
 * @brief TODO
 * @author Lukas Hostettler
 * @version 1.0
 * @date TODO
 */

#ifndef POINT_H
#define POINT_H

#ifdef __cplusplus
extern "C" {
#endif

///@brief Describes a 2D point with integer coordinates
typedef struct _IntPoint{
    int x;
    int y;
} IntPoint;

///@brief Adds (x,y) to given point
///@var x Value to add
///@var y Value to add
///@var p Point to add to
static inline void intPointAdd(IntPoint* p, int x, int y){
    p->x += x;
    p->y += y;
}

///@brief Multiplies the given point with a scalar
///@var p Point to multiply
///@var factor The scalar factor
static inline void intPointMul(IntPoint* p, int factor){
    p->x *= factor;
    p->y *= factor;
}

///@brief Gets the squared Euclidean distance between two points
///@var p1 First point
///@var p2 Second point
///@return Squared Euclidean distance
static inline int intPointSquareDist(IntPoint p1, IntPoint p2){
    return (p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y);
}

///@brief Gets the difference between two points
///@var p1 First point
///@var p2 Second point
///@return p1 - p2
static inline IntPoint intPointDiff(IntPoint p1, IntPoint p2){
    IntPoint ans = {p1.x - p2.x, p1.y - p2.y};
    return ans;
}

#ifdef __cplusplus
}
#endif

#endif //POINT_H

